Allow wineinstall to be run from tools/ or from the main Wine
[wine] / tools / wineinstall
1 #!/bin/bash
2 # WINE Installation script
3 # Can do almost everything from compiling to configuring...
4 #
5 # Copyright 1999 Ove Kåven
6 #
7 # This library is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU Lesser General Public
9 # License as published by the Free Software Foundation; either
10 # version 2.1 of the License, or (at your option) any later version.
11 #
12 # This library is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
15 # Lesser General Public License for more details.
16 #
17 # You should have received a copy of the GNU Lesser General Public
18 # License along with this library; if not, write to the Free Software
19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
20 #
21 # History:
22 # Mar 31 1999 - Ove Kåven
23 #  First version
24 # Dec 9 1999 - Ove Kåven
25 #  require Xpm
26 # Feb 25 2000 - Ove Kåven
27 #  auto-add /usr/local/lib to /etc/ld.so.conf
28 # Mar 2 2000 - Ove Kåven
29 #  source rather than grep config.cache
30 #  use sourced config.cache to start ldconfig
31 #  reconfigure if config.cache doesn't exist
32 # Mar 30 2000 - Ove Kåven
33 #  autoconfigure no-windows installs
34 #  do not install registry on real-windows installs
35 #  some support for binary package installs
36 #  set and tell user about LD_LIBRARY_PATH if necessary
37 #  set EXTRA_LD_LIBRARY_PATH in wine.conf
38 # Apr 9 2000 - Ove Kåven
39 #  make root's registry global (system-default)
40 # May 9 2000 - Ove Kåven
41 #  use ttydrv when running regapi, so we don't have to run from X
42 #  change debugger path in registry
43 # Oct 29 2000 - Ove Kåven
44 #  added --enable-opengl to default confargs
45 #  added conf_question, conf_yesno_answer, and conf_string_answer functions
46 #  added DEFCAT variable
47 # (later that day...)
48 #  added conf_reset_question function
49 #  added file existence checks to the registry copying
50 #  fixed problem with no-windows directory creation
51 #  some text reformatting from Eric Maryniak
52 # Jan 5 2000 - Chris Morgan
53 #  use default config file in /documentation/samples/config
54 #  replace .winerc with ~/.wine/config in printed text
55 #  added user question to convert .winerc file(if exists) or use the default
56 #    config file
57 #  add conf_question to allow root to install a local config file and
58 #    registry
59 # Jan 12 2000 - Chris Morgan
60 #  distinguish between creating local and global config files
61 #  display a message about the status of global config files
62 #  misc cleanups and reordering of questions
63 #  added check to see if wine is installed when we are running as a normal
64 #    user and print a message if wine cannot be found
65 # Feb 16 2002 - Adam D. Moss
66 #  Use config.status instead of config.cache to check whether we're
67 #    configured/compiled and to recreate the configuration
68 # Feb 20 2002 - Adam D. Moss
69 #  Partially revert previous changes, force configure to write an
70 #    old-style config.cache
71 # Mar 27 2002 - Chris Morgan
72 #  prevent the user from running wineinstall as root
73 #  add script commands so we su root for 'make install' and other commands
74 #    that require root access
75 #  add text to tell the user we need to run stuff as root so they don't
76 #    think we are trying to pull something funny
77 # Apr 14 2002 - Dustin Navea
78 #  Fix sed command when finding real-windows registry so it actually
79 #   accesses a file (~/.wine/config) instead of null ($CONF?!)
80 #  Added search for clean-install (not upgrade) Win2k registry
81 #  (next day, after some sleep)
82 #  Fix sed string when finding real-windows registry to actually find
83 #   windows partition name in [Drive C] section
84 #  it should now almost always find the windows partition and real-windows
85 #  registry (if not, let me know)
86 # Aug 29 2002 - Rok Mandeljc <rok.mandeljc@gimb.org>
87 #  -added two symlinks; windows/winhelp.exe and windows/winhlp32.exe because it seems
88 #   that some apps look for winhlp32.exe/winhelp to display help
89 #
90
91 #--- defaults (change these if you are a packager)
92 CONFARGS="--enable-opengl"    # configure args, e.g. --prefix=/usr --sysconfdir=/etc
93 prefix=/usr/local             # installation prefix
94 sysconfdir=$prefix/etc        # where wine.conf and the global registry are supposed to be
95 bindir=$prefix/bin            # where winelib apps will be (or are) installed
96 libdir=$prefix/lib            # where libwine.so will be (or is) installed
97 exdir=documentation/samples   # where the sample system.ini resides
98 GCONF=$sysconfdir/wine.conf   # default path of the wine.conf global config file
99 LCONF=~/.wine/config          # default path of the local config file
100 BINDIST=no                    # whether called from a binary package config script
101 DOGLOBALCONF=auto             # whether to autogenerate wine.conf
102 DOLOCALCONF=auto              # whether to autogenerate localconf
103 DOWCHK=auto                   # whether to autoconfigure existing-windows installation
104 DOWINE=auto                   # whether to autoconfigure no-windows installation
105 DOREG=auto                    # whether to install default registry
106 DOAPP=auto                    # whether to install applications, distributed with Wine
107 SYSREG=yes                    # whether to make root's registry global (system-default)
108 CONVCONF=no                   # whether we are converting an existing .winerc or not
109
110 # "make install" still installs the dlls into $libdir, but this may change in the future
111 # (DLLPATH should point to them if/when they are not in standard ld.so paths)
112 DLLPATH=$libdir/wine          # default path of the dll .so files (except libwine.so)
113
114 # having the Wine debugger launched automatically will be a plus for us
115 DEBUGGER=$bindir/winedbg      # the (installed) path of winedbg
116 HDEBUGGER=debugger/winedbg    # the (non-installed) path of winedbg
117
118 # this is only for existing-windows installs
119 WINECONF=tools/wineconf       # path to the wineconf perl script
120
121 # this is only for no-windows installs
122 WINEINI=$exdir/config         # path to the default wine config file (also used by wineconf)
123 WININI=/dev/null              # path to the default win.ini
124 SYSTEMINI=$exdir/system.ini   # path to the default system.ini
125 REGEDIT=$bindir/regedit       # path to the regedit winelib application
126 DEFREG=winedefault.reg        # path of the registry file to be fed to regedit
127 # CROOT=/var/wine             # path of the fake Drive C (asks user if not set)
128 DEFCAT=cat                    # program to cat $DEFREG with (some packages need zcat)
129 #--- end of defaults
130
131 # temporary files used by the installer
132 TMPCONF=/tmp/wineinstall.conf
133 TMPREG=/tmp/wineinstall.reg
134
135 # functions
136
137 function std_sleep {
138   sleep 1
139 }
140
141 function conf_question {
142   # parameters: $1 = importance, $2 = question-id, $3+ = message lines
143   # the first two parameters can be used by e.g. debconf in debian packages
144   # but here we just print the message
145   shift 2
146   echo
147   local LINE="$1"
148   while shift
149   do {
150     echo "$LINE"
151     LINE="$1"
152   }
153   done
154 }
155
156 function conf_reset_question {
157   # parameters: $1 = question-id
158   # this is used to flush any cached answers and "already-displayed" flags
159   shift # dummy command
160 }
161
162 function conf_yesno_answer {
163   unset ANSWER
164   while [ "$ANSWER" != 'yes' ] && [ "$ANSWER" != 'no' ]
165   do {
166     echo -n "$1"
167     read ANSWER
168   }
169   done
170 }
171
172 function conf_string_answer {
173   echo -n "$1"
174   read ANSWER
175 }
176
177 function create_windows_directories {
178   for tdir in "$CROOT/windows" "$CROOT/windows/system" "$CROOT/windows/system32" \
179               "$CROOT/windows/Start Menu" "$CROOT/windows/Start Menu/Programs" \
180               "$CROOT/Program Files" "$CROOT/Program Files/Common Files" \
181               "$CROOT/windows/Profiles" "$CROOT/windows/Profiles/Administrator" \
182               "$CROOT/windows/Fonts" "$CROOT/windows/Start Menu/Programs/Startup"
183   do [ -d "$tdir" ] || mkdir "$tdir"
184   done
185   [ -f "$CROOT/windows/win.ini" ]    || cp "$WININI"    "$CROOT/windows/win.ini"
186   [ -f "$CROOT/windows/system.ini" ] || cp "$SYSTEMINI" "$CROOT/windows/system.ini"
187 }
188
189 #creates symbolic link in windows directory to installed winelib application
190 #parameters:
191 # - name of the installed winelib application
192 # - full path to application in the winelib directory
193 function link_app {
194   ln -sf $libdir/wine/$1.exe.so $2
195 }
196
197 #puts windows applications replacements to windows directories,
198 #configures them
199 function configure_wine_applications {
200   link_app notepad      "$CROOT/windows/notepad.exe"
201   link_app regedit      "$CROOT/windows/regedit.exe"
202   link_app wcmd         "$CROOT/windows/system32/cmd.exe"
203   link_app control      "$CROOT/windows/system32/control.exe"
204   link_app winhelp      "$CROOT/windows/system32/help.exe"
205   link_app notepad      "$CROOT/windows/system32/notepad.exe"
206   link_app progman      "$CROOT/windows/system32/progman.exe"
207   link_app regsvr32     "$CROOT/windows/system32/regsvr32.exe"
208   link_app winemine     "$CROOT/windows/system32/winmine.exe"
209   link_app winver       "$CROOT/windows/system32/winver.exe"
210   link_app uninstaller  "$CROOT/windows/uninstall.exe"
211   link_app winhelp      "$CROOT/windows/winhelp.exe"
212   link_app winhelp      "$CROOT/windows/winhlp32.exe"
213 }
214
215 # startup...
216
217 echo "WINE Installer v0.73"
218 echo
219
220 if [ "$BINDIST" = 'no' ]
221 then {
222
223   if ! [ -f configure ]
224   then {
225     if [ -f ../configure ]
226     then {
227       pushd ..
228     }
229     else {
230       echo "You're running this from the wrong directory."
231       echo "Change to the Wine source's main directory and try again."
232       exit 1
233     }
234     fi
235   }
236   fi
237
238   if [ `whoami` == 'root' ]
239   then {
240     echo "You are running wineinstall as root, this is not advisable. Please rerun as a user."
241     echo "Aborting."
242     exit 1
243   }
244   fi
245
246   # check whether RPM installed, and if it is, remove any old wine rpm.
247   hash rpm &>/dev/null
248   RET=$?
249   if [ $RET -eq 0 ]; then
250     if [ -n "`rpm -qi wine 2>/dev/null|grep "^Name"`" ]; then
251       echo "Warning: Old Wine RPM install detected. Do you want to remove it first?"
252       conf_yesno_answer "(yes/no) "
253       if [ "$ANSWER" = 'yes' ]; then
254         echo "We need to remove the rpm as root, please enter your root password"
255         echo
256         echo Starting wine rpm removal...
257         su -c "rpm -e wine; RET=$?"
258         if [ $RET -eq 0 ]; then
259           echo Done.
260         else
261           echo "FAILED. Probably you aren't installing as root."
262           echo "Expect problems (library conflicts with existing install etc.)."
263         fi
264       else
265         echo "Sorry, I won't install Wine when an rpm version is still installed."
266         echo "(Wine support suffered from way too many conflicts between RPM"
267         echo "and source installs)"
268         echo "Have a nice day !"
269         exit 1
270       fi
271     fi
272   fi
273
274   # check whether wine binary still available
275   if [ -n "`which wine 2>/dev/null|grep '/wine'`" ]; then
276     echo "Warning !! wine binary (still) found, which may indicate"
277     echo "a (conflicting) previous installation."
278     echo "You might want to abort and uninstall Wine first."
279     std_sleep
280   fi
281
282   # run the configure script, if necessary
283
284   if [ -f config.cache ] && [ -f Makefile ] && [ Makefile -nt configure ]
285   then {
286     echo
287     echo "I see that WINE has already been configured, so I'll skip that."
288     std_sleep
289     # load configure results
290     . ./config.cache
291   }
292   else {
293     echo "Running configure..."
294     echo
295     if ! ./configure -C $CONFARGS
296     then {
297       echo
298       echo "Configure failed, aborting install."
299       rm -f config.cache
300       exit 1
301     }
302     fi
303     # load configure results
304     . ./config.cache
305     # make sure X was found
306     eval "$ac_cv_have_x"
307     if [ "$have_x" != "yes" ]
308     then {
309       echo "Install the X development headers and try again."
310       rm -f config.cache
311       exit 1
312     }
313     fi
314   }
315   fi
316
317   # now do the compilation and install, we need to always do this because we
318   # don't want the 'make install' command we might run to run 'make' as root
319   if [ `whoami` != 'root' ]
320   then {
321     # ask the user if they want to build and install wine
322     echo
323     echo "We need to install wine as root user, do you want us to build wine,"
324     echo "'su root' and install Wine?  Enter 'no' to continue without installing"
325     conf_yesno_answer "(yes/no) "
326
327     if [ "$ANSWER" = "yes" ]
328     then {
329       # start out with the basic command
330       sucommand="make install"
331
332       # if the user doesn't have $libdir in their ld.so.conf add this
333       # to our sucommand string
334       if [ -f /etc/ld.so.conf ]
335       then
336         if ! grep -qs "$libdir" /etc/ld.so.conf
337         then {
338           echo
339           echo "$libdir doesn't exist in your /etc/ld.so.conf, it will be added"
340           echo "when we perform the install..."
341           sucommand="$sucommand;echo $libdir>>/etc/ld.so.conf"
342         }
343         fi
344         # run ldconfig always just in case some updated files dont get linked
345         sucommand="$sucommand;$ac_cv_path_LDCONFIG"
346       fi
347
348       echo
349
350       echo "Compiling WINE. Grab a lunch or two, rent a video, or whatever,"
351       echo "in the meantime..."
352       echo
353       std_sleep
354
355       # try to just make wine, if this fails 'make depend' and try to remake
356       if ! { make; }
357       then {
358         if ! { make depend && make; }
359         then {
360           echo
361           echo "Compilation failed, aborting install."
362           exit 1
363         }
364         fi
365       }
366       fi
367       echo
368
369       echo "Performing 'make install' as root to install binaries, enter root password"
370
371       std_sleep
372
373       if ! su root -c "$sucommand"
374       then {
375         echo
376         echo "Either you entered an incorrect password or we failed to run"
377         echo "'$sucommand' correctly."
378         echo "If you didn't enter an incorrect password then please report this"
379         echo "error and any steps to possibly reproduce it to"
380         echo "http://bugs.winehq.com/"
381         echo
382         echo "Installation failed, aborting."
383         exit 1
384       }
385       fi
386
387       echo
388
389       # see if wine is installed on the users system, if not prompt them
390       # and then exit
391       if [ ! `which wine` ]
392       then
393         echo "Could not find wine on your system.  Run wineinstall as root to install wine"
394         echo "before re-running wineinstall as a user."
395         echo
396         echo "Exiting wineinstall"
397         exit 1;
398       fi
399     }
400     else {
401       # user didn't want to install wine so tell them about running from the
402       # current directory and set some stuff up for them
403
404       # setup to run from current directory
405       DLLPATH="$PWD/dlls"
406       if [ -z "$LD_LIBRARY_PATH" ]
407       then LD_LIBRARY_PATH="$PWD:$DLLPATH"
408       else LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$PWD:$DLLPATH"
409       fi
410       export LD_LIBRARY_PATH
411       DEBUGGER="$PWD/$HDEBUGGER"
412       echo
413       echo "NOTE! To run Wine without installing, you must set the environment variable"
414       echo "LD_LIBRARY_PATH to $PWD:$DLLPATH"
415       echo "in your logon scripts."
416       echo
417     }
418     fi
419   }
420   fi # [ `whoami` != 'root' ]
421
422 }
423 fi # BINDIST
424
425 # now check whether we should generate wine.conf
426 if [ -z "$DOGLOBALCONF" ]
427 then
428   DOGLOBALCONF=auto
429 fi
430
431 if [ "$DOGLOBALCONF" = 'auto' ]
432 then {
433   # see if we already have a system wine.conf
434   if [ ! -f $GCONF ] && [ `whoami` = 'root' ]
435   then
436     DOGLOBALCONF=no
437     echo "Creation of a global config file is not supported in wineinstall at this"
438     echo "time.  When the configuration architecture is cleaned up this functionality"
439     echo "will be restored to wineinstall."
440     echo
441   fi
442 }
443 fi
444
445 if [ "$DOLOCALCONF" = 'auto' ]
446 then {
447   # see if the user is root, if so, explicitly ask them if they want a
448   # local config file
449   if [ `whoami` = 'root' ]
450   then
451     echo "You are running as root.  Do you want a local config file,"
452     echo "file, ~/.wine/config, created?"
453     conf_yesno_answer "(yes/no) "
454     DOLOCALCONF="$ANSWER"
455   else
456     # if the user has an existing config file ask them if they want us to
457     # overwrite it, otherwise just ask them if they want to create one
458     if [ -f "$LCONF" ]
459     then
460       echo "Found existing $LCONF, do you want to overwrite this"
461       echo "existing Wine configuration file?"
462       conf_yesno_answer "(yes/no) "
463       DOLOCALCONF="$ANSWER"
464       echo
465       if [ "$ANSWER" = "yes" ]
466       then
467       {
468         echo "Would you like to make a backup of this old config file?"
469         conf_yesno_answer "(yes/no) "
470         echo
471         if [ "$ANSWER" = "yes" ]
472         then
473         {
474           echo "Renaming $LCONF to $LCONF.old"
475           mv -f "$LCONF" "$LCONF.old"
476           echo
477         }
478         fi
479       }
480       fi
481     else
482     {
483       echo "Create local config file ~/.wine/config?"
484       conf_yesno_answer "(yes/no) "
485       DOLOCALCONF="$ANSWER"
486       echo
487       if [ "$ANSWER" = 'no' ]
488       then
489         conf_question high need_root \
490           "Aborting install. Try again as root to generate a system wine.conf."
491         exit 1
492       fi
493     }
494     fi
495   fi
496 }
497 fi
498
499 # generate $TMPCONF from existing windows install, if any
500 if [ "$DOLOCALCONF" = 'yes' ]
501 then {
502   if [ "$DOWCHK" = 'yes' ] || [ "$DOWCHK" = 'auto' ]
503   then {
504     echo -n "Searching for an existing Windows installation..."
505     if ! $WINECONF -inifile "$WINEINI" > $TMPCONF 2>/dev/null
506     then {
507       rm -f $TMPCONF $TMPREG > /dev/null
508
509       echo " not found. (no matching /etc/fstab mount entry found)"
510       conf_question low do_without_windows \
511        "Windows was not found on your system, so I assume you want" \
512        "a Wine-only installation. Am I correct?"
513       conf_yesno_answer "(yes/no) "
514       if [ "$ANSWER" = 'no' ]
515       then {
516         conf_question high windows_not_found \
517          "Aborting install. Make sure your Windows partition is mounted and try again," \
518          "or create $LCONF manually by copying from $WINEINI and adapting the drive paths."
519         exit 1
520       }
521       fi
522       DOWINE=yes
523     }
524     else {
525       echo " found."
526
527       conf_reset_question windows_found
528       conf_question low windows_found \
529        "Created $LCONF using your existing Windows installation." \
530        "You probably want to review the file, though."
531       DOWINE=no
532     }
533     fi
534   }
535   elif [ "$DOWINE" = 'auto' ]
536   then DOWINE=yes
537   fi
538 }
539 elif [ "$DOWINE" = 'auto' ]
540 then
541   DOWINE=no
542 fi
543
544 # setup a no-windows installation, if necessary
545 if [ "$DOWINE" = 'yes' ]
546 then {
547   # set an appropriate DCROOT
548   if [ `whoami` != 'root' ]
549   then DCROOT=~/c
550   else DCROOT=/c
551   fi
552
553   if [ -f ~/.winerc ]
554   then {
555     conf_question medium convert_config \
556      "I found the old version Wine config file, .winerc, in your " \
557      "home directory.  I can convert this to the new format or use the" \
558      "new default Wine config file. Convert?"
559     conf_yesno_answer "(yes/no) "
560     if [ "$ANSWER" = 'yes' ]
561     then {
562       WINEINI=~/.winerc
563       CONVCONF=yes
564     }
565     fi
566   }
567   else {
568
569     conf_question low drivec_path \
570      "Configuring Wine without Windows." \
571      "Some fake Windows directories must be created, to hold any .ini files, DLLs," \
572      "start menu entries, and other things your applications may need to install." \
573      "Where would you like your fake C drive to be placed?"
574     while [ -z "$CROOT" ]
575     do {
576       conf_string_answer "(default is $DCROOT) "
577       [ -z "$ANSWER" ] && ANSWER="$DCROOT"
578       if ! [ -d "$ANSWER" ]
579       then {
580         if mkdir -p "$ANSWER"
581         then CROOT="$ANSWER"
582         else
583           echo "Directory $ANSWER can't be created !"
584           conf_reset_question drivec_path
585         fi
586       }
587       else CROOT="$ANSWER"
588       fi
589     }
590     done
591     echo "Configuring Wine for a no-windows install in $CROOT..."
592
593     create_windows_directories
594     configure_wine_applications
595   }
596   fi
597
598   # create $LCONF using the default config file $WINEINI
599   if [ "$DOLOCALCONF" = 'yes' ] && [ "$CONVCONF" = 'no' ]
600   then {
601     sed "s|\"Path\" = \"/c\"\$|\"Path\" = \"${CROOT}\"|" $WINEINI > $TMPCONF
602     conf_reset_question default_config
603     conf_question low default_config \
604      "Created $LCONF using default Wine configuration." \
605      "You probably want to review the file, though."
606   }
607   fi
608
609   # now we really should install the registry
610   if [ "$DOREG" = 'auto' ]
611   then DOREG=yes
612   fi
613 }
614 fi
615 echo
616
617 #install the local config file $LCONF
618 if [ "$DOLOCALCONF" = 'yes' ]
619 then
620   if [ ! -w ~/.wine ]
621   then
622     mkdir ~/.wine
623   fi
624
625   if [ "$CONVCONF" = 'no' ]
626   then
627     cp $TMPCONF $LCONF > /dev/null
628   fi
629 else
630   DOREG=no
631 fi
632
633 #install the global config file $GCONF
634 if [ "$DOGLOBALCONF" = 'yes' ]
635 then
636   if [ ! -f $sysconfdir ]
637   then
638     mkdir -p $sysconfdir
639   fi
640
641   cp $TMPCONF $GCONF > /dev/null
642 fi
643
644 # check whether we need to install default registry
645 # (not to be done if windows registry exists)
646 if [ "$DOREG" = 'auto' ]
647 then {
648   CROOT=`sed -n '/^\[Drive C\]$/,/^\[.*\]$/ s/^\"Path\" = \"\(.*\)\"/\1/p' $LCONF`
649   echo "Checking for real Windows registry..."
650   if [ -f "$CROOT/windows/system.dat" ]
651   then DOREG=no
652   elif [ -f "$CROOT/windows/system32/config/system" ]
653   then DOREG=no
654   elif [ -f "$CROOT/WINNT/system32/config/system" ]
655   then DOREG=no
656   else DOREG=yes
657   fi
658   if [ "$DOREG" = 'yes' ]
659   then echo "Not found, default Wine registry will be installed."
660   else echo "Windows registry found, will not install default Wine registry."
661   fi
662   echo
663 }
664 fi
665
666 # install default registry entries
667 if [ "$DOREG" = 'yes' ]
668 then {
669   if [ "$BINDIST" = 'no' ]
670   then {
671     echo "Compiling regedit..."
672     (cd programs/regedit; make)
673     echo
674   }
675   fi
676   echo "Preparing to install default Wine registry entries..."
677
678   # edit config files so we don't have to run regedit under X
679   if [ "$CONVCONF" = 'yes' ]
680   then
681     mv $WINEINI $WINEINI.new
682     sed "s/GraphicsDriver=.*/GraphicsDriver=ttydrv/" $WINEINI.new > $WINEINI
683   else
684     mv $LCONF $LCONF.new
685     sed "s/\"GraphicsDriver\" = .*/\"GraphicsDriver\" = \"ttydrv\"/" $LCONF.new > $LCONF
686   fi
687
688   # create a temporary wineinstall.reg with fixed debugger path
689   $DEFCAT $DEFREG | sed "s|debugger/winedbg|${DEBUGGER}|" > $TMPREG
690
691   echo "Installing default Wine registry entries..."
692   echo
693   if ! $REGEDIT $TMPREG > /dev/null
694   then {
695     rm -f $TMPREG
696     echo "Registry install failed."
697     conf_reset_question regedit_error
698     conf_question high regedit_error
699     exit 1
700   }
701   else {
702     # if we are converting from a .winerc file, running regedit once
703     # will ONLY convert .winerc -> ~/.wine/config, it will not import the
704     # registry data.  so if we are converting we need to run regedit twice
705     if [ "$CONVCONF" = 'yes' ]
706     then
707       if ! $REGEDIT $TMPREG > /dev/null
708       then
709         rm -f $TMPREG
710         echo "Registry install failed."
711         conf_reset_question regedit_error
712         conf_question high regedit_error
713         exit 1
714       else
715         echo
716         echo "Registry entries successfully installed."
717       fi
718     else
719       echo
720       echo "Registry entries successfully installed."
721     fi
722   }
723   fi
724   rm -f $TMPREG
725   if [ "$SYSREG" = 'auto' ]
726   then SYSREG=yes
727   fi
728
729   # if we converted we need to change the graphics driver back and
730   # restore the original .winerc file
731   if [ "$CONVCONF" = 'yes' ]
732   then
733      mv $WINEINI.new $WINEINI
734   fi
735
736   sed "s/\"GraphicsDriver\" = .*/\"GraphicsDriver\" = \"x11drv\"/" $LCONF > $LCONF.new
737   mv $LCONF.new $LCONF
738 }
739 fi
740
741 # make root's registry global, if desired
742 if [ `whoami` = 'root' ] && [ "$DOREG" = 'yes' ] && [ "$SYSREG" = 'yes' ]
743 then {
744   [ -d ~/.wine ] || mkdir ~/.wine
745   if ! [ -f $sysconfdir/wine.userreg ]
746   then {
747     echo "Linking root's user registry hive to the global registry..."
748     [ -f ~/.wine/wine.userreg ] && cp ~/.wine/wine.userreg $sysconfdir/wine.userreg
749     ln -sf $sysconfdir/wine.userreg ~/.wine/wine.userreg
750   }
751   fi
752   if ! [ -f $sysconfdir/wine.systemreg ]
753   then {
754     echo "Linking root's system registry hive to the global registry..."
755     [ -f ~/.wine/system.reg ] && cp ~/.wine/system.reg $sysconfdir/wine.systemreg
756     ln -sf $sysconfdir/wine.systemreg ~/.wine/system.reg
757   }
758   fi
759 }
760 fi
761
762 # cleanup any temporary files that may remain
763 if [ -f $TMPCONF ]
764 then rm -f $TMPCONF
765 fi
766 if [ -f $TMPREG ]
767 then rm -f $TMPREG
768 fi
769
770
771 # it's a wrap
772 echo
773 echo "Installation complete for now. Good luck (this is still alpha software)."
774 echo "If you have problems with WINE, please read the documentation first,"
775 echo "as many kinds of potential problems are explained there."
776
777 exit 0